
package com.nokia.m2m.sdk.examples.device;

import org.omg.CORBA.Any;
import org.omg.CORBA.IntHolder;

import java.util.Calendar;
import java.io.IOException;
import javax.microedition.io.Connector;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import javax.microedition.io.StreamConnection;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_TEXT;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_TEXTHelper;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_UNRESOLVED;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_UNRESOLVEDHelper;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_STORED;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_STOREDHelper;

import com.nokia.m2m.orb.idl.terminal.ET;
import com.nokia.m2m.orb.idl.wirelessdevice.EventObserverPOA;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;
import java.util.Vector;

/**
 * EventObserver implementation handles incoming events.
 *
 */
public class MessageObserverImpl extends EventObserverPOA {
	private final ET et;
	private Vector fifo = null;
	private StreamConnection sck = null;
	private InputStream scinStream = null;
	private OutputStream scoutStream = null;
	private String uri = "socket://129.241.219.152:53";

	public MessageObserverImpl(ET etObject, Vector fifoObject) {
		fifo = fifoObject;
		et = etObject;
		try {
			sck = (StreamConnection) Connector.open(uri, Connector.READ_WRITE, true);
			// Open outputStstream
			scoutStream = sck.openOutputStream();
			scinStream = sck.openInputStream();
			portlog("Portlog er satt opp",true);
			} catch (IOException ignored) {
			log("Could not create stream to " + uri + " " + ignored);

			return;
		}
	}
	/**
	 * Handle events
	 *
	 */
	public void eventFired(String eventName, Any eventData) {
		try {
			portlog("event fired ",true);
			//
			// Use event name to resolve the type of received event
			//
			if (eventName.equals("SMS-RECEIVED-TEXT")) {
				portlog ("SMS-RECEIVED-TEXT",true);
				SMS_RECEIVED_TEXT msg = SMS_RECEIVED_TEXTHelper.extract(eventData);
				portlog("MOI: Received message '" + msg.content + "' from " + msg.phoneNumber, true);
//				message = "tel:" + msg.phoneNumber + " " + msg.content;

				fifo.addElement( msg );
				portlog("FIFO har Strrelsen: "+ fifo.size(),true);
//				if(msg.content.toUpperCase().startsWith("ALARM OFF"))armed = false;
//				if(msg.content.toUpperCase().startsWith("ALARM ON"))armed = true;
//				if(msg.content.toUpperCase().startsWith("LOAD ")){
//					address = msg.content.substring(5);
//					urlflag = true;
//					}
				// Send message back
//				IntHolder ih = new IntHolder();
//				if(msg.content.toUpperCase().startsWith("ALARM"))et.sendShortMessage( msg.phoneNumber, "ALARM STATUS: " + armed , ih);
//				else et.sendShortMessage( msg.phoneNumber, "Nokia12: " + msg.content , ih);

			} else if (eventName.equals("SMS-RECEIVED-UNRESOLVED")) {
				// binary short message
				SMS_RECEIVED_UNRESOLVED msg = SMS_RECEIVED_UNRESOLVEDHelper.extract(eventData);
				log("Received binary message '" + new String(msg.content) + "' from " + msg.phoneNumber);
				// Don't send back

			} else if (eventName.equals("SMS-RECEIVED-STORED"))  {
				SMS_RECEIVED_STORED msg = SMS_RECEIVED_STOREDHelper.extract(eventData);
				portlog("Received message stored" + msg,true);

			} else {
				log("MOI: Can't recognize event " + eventName);
			}
		} catch (Exception e) {
			log("MOI: " + e.toString());
		}
	}

	/**
	 * Writes a message to the serial port
	 * @param msg
	 */
	private void log(String msg) {
		SerialPortLogger.getInstance().write("ObserverImpl: " + msg);
	}
	public void portlog(String msg, boolean flag) {
		if (scoutStream != null && msg != null) {
			// prepare timestamp
			Calendar cal = Calendar.getInstance();
			if(msg.startsWith("$INI")) {
			//command =true;
			}
			// Print timestamp and message
			if(flag)msg = "$LOG: <[" + cal.toString().substring(5,25) + "] " + msg + ">\r";
			try {
			scoutStream.write(msg.getBytes());
			//				log("Done writing to outStream");
			} catch (IOException ignored) { log("Could not write message to " + uri + " " + ignored);
			}
		}
	}
}
