package com.nokia.m2m.sdk.examples.device;

import com.nokia.m2m.imp.comm.CommConnection;
import com.nokia.m2m.imp.iocontrol.IOControl;
import com.nokia.m2m.orb.idl.iomodule.IOControlHelper;
import com.nokia.m2m.orb.idl.iomodule.IOControlObserverHelper;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_TEXT;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistration;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistrationHelper;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistrationStatus;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.Operator;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.OperatorListHelper;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.SignalQualityHelper;
import com.nokia.m2m.orb.idl.terminal.ET;
import com.nokia.m2m.orb.idl.terminal.ETHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.Device;
import com.nokia.m2m.orb.idl.wirelessdevice.DeviceHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.EventObserverHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.ParamObserverHelper;
import com.nokia.m2m.sdk.examples.iomodule.*;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;
import com.nokia.m2m.sdk.examples.logger.SocketPortLogger;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;
import java.util.TimeZone;
import java.util.Vector;
import java.util.Enumeration;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.io.StreamConnection;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.wireless.messaging.MessageConnection;
import javax.wireless.messaging.TextMessage;
import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.CORBA.Policy;
import org.omg.PortableServer.IdAssignmentPolicyValue;
import org.omg.PortableServer.IdUniquenessPolicyValue;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import java.lang.Integer;
import java.io.IOException;


/**
 * MessageObserverIMlet listens for incoming short messages and sends
 * a response message back to the sender. This implementation uses
 * event listener approach.
 *
 *
 */
public class SeatexIMlet extends MIDlet {

	ORB orb;
	private static final int OUTPUT_PIN_1 = 7;
	private static final int OUTPUT_PIN_2 = 6;
	private static final int OUTPUT_PIN_3 = 9;
	private static final int INPUT_PIN_1 = 6; // toggle
	private static final int INPUT_PIN_2 = 9; // toggle
	private static final int INPUT_PIN_3 = 7; // switch
	private static final String urls[] = {"sms://+4792421325" };							// Dette er nummeret som meldingene sendes til
	private static final String version = "1.0a";											// Nytt i denne versjonen er mottak av data fra Serveren og mating av data til GPS-mottaker
	private static final Vector fifo = new Vector();										// En vektor er en array med objekter som kan forandre strrelse
	private static final Vector inData = new Vector();
	private static final int year = 2006;													// Datoen i dag
	private static final int month = 01;
	private static final int dato = 19;
	private int cell_id;																	// Dette er en variable som cellID fra GSM nettet lagres i.
	private int LAC;
	private String uri = "socket://129.241.219.152:53";

	private StreamConnection sck = null;
	private InputStream scinStream = null;
	private OutputStream scoutStream = null;

	private OutputStream outStream = null;
	private StreamConnection sc = null;
	private InputStream inStream = null;
		// UBX protocol headers
	final static String AID_DATA  = "#b5#62#0b#10";		// Start of AID_DATA msg
	final static String CFG_MSG   = "0xb50x620x060x010x030x000x0b0x000x010x160x61";	// Request aiding on default
	final int[] int_CFG_MSG   = { 0xb5,0x62,0x06,0x01,0x03,0x00,0x0b,0x00,0x01,0x16,0x61 } ;	// Request aiding on default
	final static String CFG_RST   = "0xb50x620x060x040x040x000xff0xff0x020x000x0e0x61";	// Cold reset
	final int[] int_CFG_RST = { 0xb5,0x62,0x06,0x04,0x04,0x00,0xff,0xff,0x02,0x00,0x0e,0x61 }; // Cold reset

	/**
	 * Start application
	 */
	protected void startApp() throws MIDletStateChangeException {
		try {
					sck = (StreamConnection) Connector.open(uri, Connector.READ_WRITE, true);
					// Open outputStstream
					scoutStream = sck.openOutputStream();
					scinStream = sck.openInputStream();
				} catch (IOException ignored) {
					log("Could not create stream to " + uri + " " + ignored);
					return;
		}

		try {
			// Setter frst kalenderen og klokka.
/*			Calendar cal = Calendar.getInstance();
			cal.setTimeZone(TimeZone.getTimeZone("GMT"));
			cal.set(Calendar.YEAR,year);
			cal.set(Calendar.MONTH,month);
			cal.set(Calendar.DATE,dato);
			cal.set(Calendar.HOUR, 15);
			cal.set(Calendar.MINUTE, 30); */

			portlog("SeatexIMlet starting ver. " + version + " " + dato + "." + month + "." + year + ", Telenor ASA, Sune Jakobsson",true); // Logger
			// Initialize ORB in IIOP mode. This IMlet does not do wireless
			// communications.
			Hashtable props = new Hashtable();												// Definerer et nytt objekt av typen Hashtable
			props.put("com.nokia.m2m.orb.UseM2MGateway", "no");								// Putter Streng inn i hashtabellen
			orb = ORB.init(null, props);
			//
			// Get the RootPOA.
			//
			org.omg.PortableServer.POA rootPoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));



			// Create a new POA. Use persistent policies
			// so that servants activated under
			// this POA will always get the same IOR. This ensures
			// that when the IMlet is restarted
			// after Nokia 12 module reboot, the new reqistration will
			// overwrite the existing reqistration.
			//
			Policy[] policies =
				new Policy[] {
					rootPoa.create_id_assignment_policy(IdAssignmentPolicyValue.USER_ID),
					rootPoa.create_id_uniqueness_policy(IdUniquenessPolicyValue.UNIQUE_ID),
					rootPoa.create_lifespan_policy(LifespanPolicyValue.PERSISTENT)};


			//
			// Name the new POA as 'SmsObserverPOA' this name will be part of
			// the listener objects object key. Object key can be freely chosen.
			//
	//		POA observerPoa = rootPoa.create_POA("ObserverPOA", rootPoa.the_POAManager(), policies);

			// Resolve the Embedded Terminal object. This is needed to send response shortmessages.
			String etUrl =  "corbaloc::127.0.0.1:19740/ORB/OA/IDL:ET:1.0";

			org.omg.CORBA.Object etRef = orb.string_to_object(etUrl);

			ET et = ETHelper.narrow(etRef);

			String deviceUrl =  "corbaloc::127.0.0.1:19740/Device";

			org.omg.CORBA.Object deviceRef = orb.string_to_object(deviceUrl);

			Device device=DeviceHelper.narrow(deviceRef);

			device.removeAllObservers();

			// Get a reference to the IO module
			String ioUrl = "corbaloc::127.0.0.1:19740/ORB/OA/IDL:IOModule/IOControl:1.0";
			org.omg.CORBA.Object ioRef = orb.string_to_object(ioUrl);

			com.nokia.m2m.orb.idl.iomodule.IOControl iocontrol = IOControlHelper.narrow(ioRef);
			//
			// Initialize the servant object. Give embedded terminal to the observer so that it can
			// use et methods to send response shortmessage back to the sender. Object id can be freely
			// chosen.
			//

			MessageObserverImpl messObserverImpl = new MessageObserverImpl(et, fifo);
			//observerPoa.activate_object_with_id("SMSObserver".getBytes(), messObserverImpl);
			SignalQualityObserverImpl sigObserverImpl = new SignalQualityObserverImpl();
			//observerPoa.activate_object_with_id("SignalQualityObserver".getBytes(), sigObserverImpl);
//			IOControlObserverImpl ioObserverImpl = new IOControlObserverImpl();
//			observerPoa.activate_object_with_id("IOObserver".getBytes(), ioObserverImpl);
			//
			// Activate the POAManager.
			// Activation starts request processing in all POAs that
			// use this POAManager.
			//
			rootPoa.the_POAManager().activate();
			//
			// The observer is now ready to receive events.
			// Register the listener into the Module ORB.
			//
			// Get CORBA object reference from servant
/*			Object messObserverObj = observerPoa.servant_to_reference(messObserverImpl);
			Object sigObserverObj = observerPoa.servant_to_reference(sigObserverImpl);
//			Object ioObserverObj = observerPoa.servant_to_reference(ioObserverImpl);
			portlog("Setting observers",true);
/*			try {
					// Start to listen to the SMS reception.
					device.setEventObserver("SMS-RECEIVED-TEXT", EventObserverHelper.narrow(messObserverObj));
			}
			catch (Exception e) {portlog("Failed setting observers: SMS-RECEIVED-TEXT" + e , true); }
			try {
					// Activate also SMS-RECEIVED-UNRESOLVED if you want to receive binary short messages.
					// Same observer object can be set to listen multiple different events
					device.setEventObserver("SMS-RECEIVED-UNRESOLVED", EventObserverHelper.narrow(messObserverObj));
			}
			catch (Exception e) {portlog("Failed setting observers: SMS-RECEIVED-UNRESOLVED" + e , true); }
			try {
					// Start to listen to the SignalQuality parameter.
					device.setParamObserver("SignalQuality", ParamObserverHelper.narrow(sigObserverObj));

//					short[] pinList = new short[] { 5, 6, 7, 8, 9, 10, 11 };
//					iocontrol.setIOControlObserver(IOControlObserverHelper.narrow(ioObserverObj),pinList);
			  }
			catch (Exception e) {portlog("Failed setting observers: SignalQuality" + e , true); }

			portlog("Observers are set. Waiting for events...",true); */
// ----------------------------------------------------------------------
			org.omg.CORBA.AnyHolder nval = new org.omg.CORBA.AnyHolder();
			boolean n_wait = true;

			while(n_wait){

			device.getParam("NetworkRegistration",nval);
			NetworkRegistration yy = NetworkRegistrationHelper.extract(nval.value);
			NetworkRegistrationStatus nrs = yy.status;
			portlog("status is: " + nrs.value(), true); // Vent til denne er 1. NETWORK_REGISTRATION_REGISTERED_HOME
			LAC = yy.areaCode;
			portlog("areaCode is: " + LAC, true);										// Henter og logger LAC
			cell_id = yy.cellID;
			portlog("cellID is: " + cell_id, true); 									// Henter og logger cellID. cellID har en tendens til  feile.

//			if(nrs.value() == NetworkRegistrationStatus.NETWORK_REGISTRATION_REGISTERED_HOME) n_wait = false;
			if(nrs.value() == 1) n_wait = false;
			};
// ----------------------------------------------------------------------
//			log("Show operator");
//			showOperator(); // takes a long time, and fails occationally??
//			log("Done with operator");
// ----------------------------------------------------------------------
			// Henter signalkvalitet. er dette SNR?
			org.omg.CORBA.AnyHolder sval = new org.omg.CORBA.AnyHolder();
			device.getParam("SignalQuality",sval);
			short sVal= SignalQualityHelper.extract(sval.value);
			portlog("GSM Signal Quality is: " + sVal, true);
			sigObserverImpl.setValue(sVal);
// ----------------------------------------------------------------------
			// Ask IMEI from the embedded terminal
			portlog("IMEI=" + et.IMEI(), true);											// Henter og logger IMEI
//			log("Now: " + System.currentTimeMillis());
			boolean set1=false;
			boolean set2=false;
			boolean set3=false;
			int i = 0;
			int ad0 = 0;

//			ioObserverImpl.resetChange(5);
//			ioObserverImpl.resetChange(11);
			sendSMS(urls[0],"Seatex unit power up, version: " + version);				// Sender SMS til nummeret som er angitt i linje 71

			portlog("Unit: " + et.IMEI() + " is running", true);
			portlog("$INIT,UBX," + et.IMEI() + "," + cell_id + "," + LAC + "\r", false);

			portlog("$INI\r", false); 													// Ber serveren om  f overfrt INI data
			portlog("$ALM\r", false);													// Ber serveren om  f overfrt almanac data
			portlog("$EPH\r", false);

			try {
			sc = (StreamConnection) Connector.open("comm:3;baudrate=57600", Connector.READ_WRITE); // pner en ny streamconnection mot com3
			// Open outputStream
			outStream = sc.openOutputStream();											// pner bde input og output stream
			inStream = sc.openInputStream();
		} catch (IOException ignored) { portlog("Failed opening of serial port to GPS device", true);
		}

			byte[] inbuffer = new byte[4096];											// Definerer et inngangsbuffer for  ta imot data fra strmmen
			int [] INI_DATA = new int[56];
			int [][] ALM_DATA = new int[32][48];
			int [] ALM_CHK = new int[48];
			int [][] EPH_DATA = new int[32][112];
			int [] EPH_CHK = new int[112];
			int [] U4 = new int[4];
			int [] I4 = new int[4];
			int [] U2 = new int[2];
			int [] I2 = new int[2];
			boolean [] ALM_ok = new boolean[32];										// Denne arrayen bekrefter at almanakk meldingene er OK og kan sendes til GPS mottakeren
			boolean [] EPH_ok = new boolean[32];										// Denne variabelen bekrefter at ephemeris meldingen er OK og kan sendes til GPS mottakeren
			int b=0;
			int c=0;
			int inputbytes=0;
			int actual=0;
			int fix_count_2d=0;
			int fix_count_3d=0;
			int numSV=0;
			long PRN=0;
			long ITOW=0;
			long TTFF3d=0;
			long TTFF=0;
			boolean gps_boot = true;
			boolean gps_reset = true;
			boolean serial_ack = false;
			boolean gps_aid = false;													// Denne variabelen styrer om vi vil hjelpe GPS mottakeren
			boolean INI_ok = false;
			String NAV_INI ="";
			while (true){
				// Dette er en evig slyfe
				try
				{
				inputbytes = inStream.available();										// Finner lengden p inputstream hvis det finnes noen
				if(inputbytes > 0){
					// hvis data finnes utfres denne slfen
					actual = inStream.read(inbuffer, 0 , inputbytes);					// Henter data ifra innstrmmen og legger disse inn i arrayet inbuffer. 0 er offset slik at
																						// dataene legges fra inbuffer[0+0] til inbuffer[inputbytes-1]. Antallet bytes som leses legges i variabelen actual
					// Den etterflgende for slyfen sjekker inndataene og behandler de ette hva slags type de er.
					int starts = 0;
					for(int ix = 0; ix < actual ; ix++)if(inbuffer[ix] == (byte)0xB5) // Every Message starts with 2 Bytes: 0xB5 0x62
						{
						if(inbuffer[ix+1] == (byte)0x62)
							{
							starts++;	 //		A 1 Byte Class Field follows. The Class defines the basic subset of the message

							switch(	inbuffer[ix+2] )
								{
								case (byte)0x01: 										// Dette er klassen NAV som gir navigasjonsresultater: posisjon, hastighet, tid, nyaktighet, retning, DOP og satelitter
																	if(inbuffer[ix+3] == (byte)0x01)  {
																		portlog("NAV-POSECEF (0x01 0x01)",true);
																		for (int z=0; z < 4; z++)  {
																		  U4[z] = inbuffer[ix + 6 + z];
																		}
																		long TOW = U4tolong(I4);
																		portlog("TOW = " + TOW,true);
																		for (int z=0; z < 4; z++)  {
																			I4[z] = inbuffer[ix + 10 + z];
																		}
																		int ecef_x = I4toInt(I4);
																		portlog("ECEF-X = " + ecef_x,true);
																		for (int z=0; z < 4; z++)  {
																			I4[z] = inbuffer[ix + 14 + z];
																		}
																		int ecef_y = I4toInt(I4);
																		portlog("ECEF-Y = " + ecef_x,true);
																		for (int z=0; z < 4; z++)  {
																			I4[z] = inbuffer[ix + 18 + z];
																		}
																		int ecef_z = I4toInt(I4);
																		portlog("ECEF-Z = " + ecef_x,true);
																	}
																	if(inbuffer[ix+3] == (byte)0x02)  {
																		// Denne NAV meldingen viser posisjon
																		portlog("NAV-POSLLH (0x01 0x02)	",true);
																		//Finner frst Longitude

																		for (int z=0; z < 4; z++)  {
																			I4[z] = inbuffer[ix + 10 + z];
																		}
																		int Longitude = I4toInt(I4);
																		// Finner Latitude
																		for (int z = 0; z < 4; z++)  {
																			I4[z] = inbuffer[ix + z+ 14];
																		}
																		int Latitude = I4toInt(I4);
																		// Finner hyde over havet
																		for (int z = 0; z < 4; z++)  {
																			I4[z] = inbuffer[ix + z + 18];
																		}
																		int HOS = I4toInt(I4);
																		portlog("Your position is: Longitude: " + Longitude + "e-7 deg, Latitude: " + Latitude + "e-7 deg, Height over mean sea level: " + HOS + " mm", true);
																	}
																	if(inbuffer[ix+3] == (byte)0x03)  {
																		portlog("NAV-STATUS (0x01 0x03)	",true);
																		// Henter tiden for time to first fix
																		for(int z = 0; z < 4; z++)  {
																			U4[z] = inbuffer[ix + z + 14];
																		}
																		TTFF = U4tolong(U4);
																		// Sjekker om vi har 2d fix
																		if(inbuffer[ix+10] == (byte)0x02)  {
																			fix_count_2d++;
																			if (fix_count_2d == 1)  {
																				// Henter ITOW
																				for (int z=0; z < 4; z++)  {
																					U4[z] = inbuffer[ix + 6 + z];
																				}
																				ITOW = U4tolong(U4);
																			}
																			portlog("You've got 2D-fix after " + TTFF + " ms", true);
																			//portlog("$MEAS: You've got 2D-fix after " + TTFF + " ms", false);
																		}
																		for(int z = 0; z < 4; z++)  {
																			U4[z] = inbuffer[ix + z + 14];
																		}
																		TTFF = U4tolong(U4);
																		if(inbuffer[ix+10] == (byte)0x03)  {
																			fix_count_3d++;						// Sjekker om dette er frste gang vi har 3dfix
																			if (fix_count_3d == 1)  {
																				for (int z=0; z < 4; z++)  {
																					U4[z] = inbuffer[ix + 6 + z];
																				}
																				if (fix_count_2d != 0)  {
																					TTFF3d = U4tolong(U4) - ITOW + TTFF;
																				} else {
																					TTFF3d = TTFF;
																				}
																			}
																		portlog("You've got 3D-fix after " + TTFF3d + " ms", true);
																		//portlog("$MEAS: You've got 3D-fix after " + TTFF3d + " ms", false);
																		}
																	}
																	if(inbuffer[ix+3] == (byte)0x04)portlog("NAV-DOP (0x01 0x04)		",true);
																	if(inbuffer[ix+3] == (byte)0x06)  {
																		portlog("NAV-SOL (0x01 0x06)		",true);
																		numSV = inbuffer[ix+53];
																		portlog("Number of Satelites used in this positioning is: " + numSV,true);
																	}
																	if(inbuffer[ix+3] == (byte)0x08)portlog("NAV-POSUTM (0x01 0x08)	",true);
																	if(inbuffer[ix+3] == (byte)0x11)portlog("NAV-VELECEF (0x01 0x11)",true);
																	if(inbuffer[ix+3] == (byte)0x12)portlog("NAV-VELNED (0x01 0x12)	",true);
																	if(inbuffer[ix+3] == (byte)0x20)portlog("NAV-TIMEGPS (0x01 0x20)",true);
																	if(inbuffer[ix+3] == (byte)0x21)portlog("NAV-TIMEUTC (0x01 0x21)",true);
																	if(inbuffer[ix+3] == (byte)0x22)portlog("NAV-CLOCK (0x01 0x22)	",true);
																	if(inbuffer[ix+3] == (byte)0x30)portlog("NAV-SVINFO (0x01 0x30)	",true);
																	if(inbuffer[ix+3] == (byte)0x31)portlog("NAV-DGPS (0x01 0x31)		",true);
																	if(inbuffer[ix+3] == (byte)0x32)portlog("NAV-SBAS (0x01 0x32)		",true);
																	if(inbuffer[ix+3] == (byte)0x40)portlog("NAV-EKFSTATUS (0x01 0x40)",true);
																	break;

								case (byte)0x02: portlog(" RXM Receiver Manager Messages: Pseudo Ranges, avg C/N0, Channel Status",true); break;	// Dette er klassen RXM som gir meldinger fra mottaker: pseudo range midlere C/N0 og kanalstatus.

								case (byte)0x04: 										// Dette er klassen INF som gir informative meldinger (ASCII tekst): Error, Warning og Notice
																	if(inbuffer[ix+3] == (byte)0x00)portlog("INF-ERROR (0x04 0x00)  ",true);
																	if(inbuffer[ix+3] == (byte)0x02)
																		{
																		String conv = new String(inbuffer, (ix+6) , (int)inbuffer[ix+4]);
																		if(conv.startsWith("ANTARIS"))gps_boot = true;
																		if(conv.startsWith("Reset"))gps_reset = true;
																		portlog("INF-NOTICE (0x04 0x02) " + inbuffer[ix+4] + " " + inbuffer[ix+5] + " " + conv,true);
																		}
																	if(inbuffer[ix+3] == (byte)0x03)portlog("INF-TEST (0x04 0x03)   ",true);
																	if(inbuffer[ix+3] == (byte)0x04)portlog("INF-DEBUG (0x04 0x04)  ",true);
																	if(inbuffer[ix+3] == (byte)0x07)portlog("INF-USER (0x04 0x07)   ",true);
								                  if(inbuffer[ix+3] == (byte)0x01)portlog("INF-WARNING (0x04 0x01)",true);
																	break;

								case (byte)0x05:										// Dette er klassen ACK/NACK som er svar p CFG meldinger sendt til GPS enheten
																	if(inbuffer[ix+3] == (byte)0x01)
																		{
																		portlog("ACK-ACK (0x05 0x01)",true);
																		serial_ack = true;
																		}
																	if(inbuffer[ix+3] == (byte)0x00)portlog("ACK-NAK (0x05 0x00)",true);
																	break;
								case (byte)0x06: portlog(" CFG Configuration Input Messages: Set Dynamic Model, Set DOP Mask",true); break;	// Dette er klassen CFG som er configurasjonsmeldinger som sendes til GPS mottakeren.

								case (byte)0x09: portlog(" UPD Firmware Update Messages",true);  break;	// Dette er klassen UPD som er firmware update meldinger

								case (byte)0x0A: 										// Dette er klassen MON som gir overvkningsmeldinger: Stackbruk, kommunikasjonsstatus, CPU-last, IPC status og oppgavestatus
																	if(inbuffer[ix+3] == (byte)0x01)portlog("MON-SCHD (0x0A 0x01)  ",true);
																	if(inbuffer[ix+3] == (byte)0x02)portlog("MON-IO (0x0A 0x02)    ",true);
																	if(inbuffer[ix+3] == (byte)0x03)portlog("MON-IPC (0x0A 0x03)   ",true);
																	if(inbuffer[ix+3] == (byte)0x04)portlog("MON-VER (0x0A 0x04)   ",true);
																	if(inbuffer[ix+3] == (byte)0x05)portlog("MON-EXCEPT (0x0A 0x05)",true);
																	if(inbuffer[ix+3] == (byte)0x06)portlog("MON-MSGPP (0x0A 0x06) ",true);
																	if(inbuffer[ix+3] == (byte)0x07)portlog("MON-RXBUF (0x0A 0x07) ",true);
																	if(inbuffer[ix+3] == (byte)0x08)portlog("MON-TXBUF (0x0A 0x08) ",true);
																	if(inbuffer[ix+3] == (byte)0x09)portlog("MON-HW (0x0A 0x09)    ",true);
																	break;

								case (byte)0x0B: portlog(" AID Navigation Aiding: Ephemeris, Almanac feeds",true); // Dette er klassen AID som er navigasjonshjelp som sendes til GPS mottakeren: Ephemeris, Almanakk.
																	if(inbuffer[ix+3] == (byte)0x00)portlog("GPS receiver asks for navigation aid",true);
																	break;

								case (byte)0x0D: portlog(" TIM Timing: Timepulse Output, Timemark Results",true); break;    // Dette er klassen TIM

								case (byte)0x40: portlog(" USR SCK Customer Messages",true); break;	// Dette er typen USR

								default: portlog("Unknown Class field: " + inbuffer[ix+2], true);  	// Hvis ingen av klassene over vil dette logges
								}
							}
						}
//					portlog("Got: " + actual+ " bytes with " + starts + " array starts with " + inbuffer[0] + " " + inbuffer[1]+ " " +
//					inbuffer[2] + " " + inbuffer[3]+ " " + inbuffer[4] + " " + inbuffer[5]+ " " + inbuffer[6] + " " + inbuffer[7],true);
					}
				}
				catch (Exception e) {System.out.println("Serial port Exception: "+ e ); }





					try {
				 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_1, (i&1)== 0);
				 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_2, (i&2)== 0);
				 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_3, (i&4)== 0);

//				 		ad0 = IOControl.getInstance().getAnalogInputPin (1);

				 			set1 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_1);
				 			set2 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_2);
				 			set3 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_3);
				  	 }
				   catch (Exception e) {System.out.println("IO Exception: "+ e ); }

				try {
					Thread.sleep(500); 																// Tar pause 500 ms
					} catch (InterruptedException interrupted)
					{portlog("Interupt exception", true);}

				if(fifo.size()>0)
					{
					for ( Enumeration e = fifo.elements(); e.hasMoreElements() ;) {

								SMS_RECEIVED_TEXT msg = (SMS_RECEIVED_TEXT)e.nextElement();
								String content = msg.content;
								String from = msg.phoneNumber;
         				portlog("MSG: " + content + "' from " + from , true);
         				if(content.toUpperCase().startsWith("LOAD "))loadLink(content.substring(5));
         				if(content.toUpperCase().startsWith("OPEN "))openLink(content.substring(5));
     						}

     			fifo.removeAllElements();
					};

				int got = 0;
						try {
							got = scinStream.available();
							//portlog("det har kommet data: " + got,true);
							if(got > 0){
								byte[] data = new byte[got];
					       		int actually = scinStream.read(data);
								inData.addElement(data);
								//portlog("Actually got: " + actually + " : " + new String(data),true);
				          	}
						}
				        catch (IOException ignored) { log("Could not read message from " + uri + " " + ignored);
		}


				if(inData.size()>0)
					{
					for ( Enumeration e = inData.elements(); e.hasMoreElements() ;) {
						byte[] data = new byte [10000];
						data = (byte[])e.nextElement();
						for(int ix = 0; ix < data.length ; ix++)
						if(data[ix] == (byte)0xB5)  {// Every Message starts with 2 Bytes: 0xB5 0x62
							if(data[ix+1] == (byte)0x62)  {
								if(data[ix+2] == (byte)0x0b)  {
									switch(	data[ix+3] )
										{
										case (byte)0x01:	portlog("AID-INI message received",true);
															/*portlog("Length of data: " + (int)data[ix+4],true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+6+a];
															}
															portlog("ECEFx = " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+10+a];
															}
															portlog("ECEFy = " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+14+a];
															}
															portlog("ECEFz = " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																U4[a] = (int)data[ix+18+a];
															}
															portlog("Posacc = " + U4tolong(U4), true);
															for(int a=0; a<2; a++)  {
																U2[a] = (int)data[ix+22+a];
															}
															portlog("Timemark = " + U2toInt(U2), true);
															for(int a=0; a<2; a++)  {
																U2[a] = (int)data[ix+24+a];
															}
															portlog("Week Number = " + U2toInt(U2), true);
															for(int a=0; a<4; a++)  {
																U4[a] = (int)data[ix+26+a];
															}
															portlog("Time = " + U4tolong(U4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+30+a];
															}
															portlog("Time (ns) = " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+34+a];
															}
															portlog("Time acc ms = " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+38+a];
															}
															portlog("Time acc ns= " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+42+a];
															}
															portlog("Clockdrift = " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+46+a];
															}
															portlog("Clockdrift acc = " + I4toInt(I4), true);
															for(int a=0; a<4; a++)  {
																I4[a] = (int)data[ix+50+a];
															}
															portlog("Flags = " + I4toInt(I4), true);*/

															for (int a=0; a < 56; a++)  {
																INI_DATA[a] = data[ix+a];
															}
															INI_ok = checksum_ok(INI_DATA);
															if (INI_ok&&gps_aid)  {
																portlog("$INI_ACK",false);
																sendIntArray(INI_DATA);
																portlog("Sending AID-INI Message to GPS receiver", true);
															}
															if (!gps_aid)  {
																portlog("No aiding used",true);
															}
															break;

										case (byte)0x30:	portlog("AID-ALM message received",true);
															for (int a=0; a < 48; a++)  {
																ALM_DATA[b][a] = data[ix+a];
															}
															for (int a=0; a < 48; a++)  {
																ALM_CHK[a] = ALM_DATA[b][a];
															}
															for(int a=0; a<4; a++)  {
																U4[a] = (int)data[ix+6+a];
															}
															PRN=U4tolong(U4);
															portlog("Satelite Number = " + PRN, true);
															ALM_ok[b] = checksum_ok(ALM_CHK);
															if (ALM_ok[b]&&gps_aid)  {
																portlog("$ALM_ACK", false);
																sendIntArray(ALM_CHK);
																portlog("Sending AID-ALM Message to GPS receiver", true);
															}
															if (!gps_aid)  {
																portlog("No aiding used",true);
															}
															b++;
															break;

										case (byte)0x31:	portlog("AID-EPH message received",true);
															for (int a=0; a < 112; a++)  {
																EPH_DATA[c][a] = data[ix+a];
															}
															for (int a=0; a < 112; a++)  {
																EPH_CHK[a] = EPH_DATA[c][a];
															//portlog("EPH_CHK["+a+"]= "+ EPH_CHK[a] + " og EPH_DATA[" + c + "][" + a +"]= " + EPH_DATA[c][a], true);
															}
															for(int a=0; a<4; a++)  {
																U4[a] = (int)data[ix+6+a];
															}
															PRN=U4tolong(U4);
															portlog("Satelite Number = " + PRN, true);

															EPH_ok[c] = checksum_ok(EPH_CHK);
															if (EPH_ok[c]&&gps_aid)  {
																portlog("$EPH_ACK", false);
																sendIntArray(EPH_CHK);
																portlog("Sending AID-EPH Message to GPS receiver", true);
															}
															if (!gps_aid)  {
																portlog("No aiding used",true);
															}
															c++;

															break;
										}
								}
							}
						}

					}

     			inData.removeAllElements();
				};

				if(gps_boot)
				{
					serial_ack = false;
					//sendString(CFG_RST);
					sendIntArray(int_CFG_RST);
					portlog("Send coldstart to GPS receiver", true);
					gps_boot = false;
				}

				if(gps_reset && serial_ack)
				{
					sendIntArray(int_CFG_MSG);
					portlog("Send configuration to GPS receiver", true);
					gps_reset = false;
				}

				//if(gps_aid && INI_ok)
				//{
				//	serial_ack = false;
				//	sendString(NAV_INI);
				//	portlog("Send navigation INI (Almanac) to GPS receiver", true);
				//	gps_boot = false;
				//}

				if((i%8)==0)
				{
				portlog(". Main: " + set1 + " " + set2 + " " + set3 + " FIFO: " + fifo.size() , true);

				}
				i++;
				}
//			orb.run();

		} catch (Exception e) {
			portlog("Error: " + e.toString(), true);
		}
		portlog("IMlet exited", true);
	}
	/**
	 * Writes a message to the serial port
	 * @param msg
	 */
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	/*private void portlog(String msg, boolean flag) {
		SocketPortLogger.getInstance().write(msg, flag);

	}*/


	//private void readVector(Vector Data)  {
	//	SocketPortLogger.getInstance().readVector(Data);
	//}
	/**
	 * Write a string of data to serial interface
	 * Data must be on the form 0x0b0xff
	 * @param data
	 */
	private void sendIntArray(int[] data)  {
		for (int i=0; i<data.length; i++)  {
			try  {
				outStream.write(data[i]&0xff);
			}  catch  (IOException e)  {
				e.printStackTrace();
			}
		}
	}
	private void sendString(String data) {
			int c = 0;
			String b="";
			if (data.length()%4 != 0) {
				portlog("Error: each byte in data must have 4 characters (0x12). Data=" + data, true);
				return;
			}
			String str="";
			portlog("Sending: " + data, true);
			for (int i = 0; i < data.length(); i+=4) {
				b=data.substring(i+2, i+4);
				c = Integer.parseInt(b,16);

				try {
					outStream.write(c);
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
	}


	protected void pauseApp() {
		// This is not needed
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		// This is not needed
	}

	private void loadLink( String urli ) {

		portlog("Attempt to load: " + urli, true);

	       HttpConnection c = null;
         InputStream is = null;
         try {
             c = (HttpConnection)Connector.open(urli, Connector.READ, true);
             // Getting the InputStream will open the connection
             // and read the HTTP headers. They are stored until
             // requested.
            }
         catch (Exception e) {portlog("Connector open Exception: " + e , true ); return; }

         try {
             is = c.openInputStream();
            }
             catch (Exception e) {portlog("Input stream open Exception: " + e , true ); return; }
					try {
             // Get the ContentType
//             String type = c.getType();
             // Get the length and process the data
//             int len = (int)c.getLength();

//             log("Opened connection with lenght: " + len + " and type: " + type);

             if (true) {
//             if (len > 0) {
                 byte[] data = new byte[64*8];
                 int actual = is.read(data);
//                 log("Actually got: " + actual + " bytes of type " + type);
                 portlog( new String(data), true);

             } else {
                 int ch;
                 while ((ch = is.read()) != -1) {
                 }
             }
      }
   catch (Exception e) {portlog("HTTP Exception: " + e , true); }

      finally {
      		try {
             if (is != null)is.close();
             if (c != null)c.close();
                } catch (Exception e) {portlog("Close HTTP Exception: " + e, true ); }
         }
      }

	private void openLink( String urli ) {

		portlog("Attempt to open: " + urli, true);

	       StreamConnection c = null;
         OutputStream os = null;
         try {
//             c = (StreamConnection)Connector.open(urli, Connector.WRITE, true);
             os = Connector.openOutputStream(urli);
             // Getting the InputStream will open the connection
             // and read the HTTP headers. They are stored until
             // requested.
//            }
//         catch (Exception e) {log("Connector open Exception: " + e  ); return; }

//         try {
//             os = c.openOutputStream();
            }
             catch (Exception e) {portlog("Output stream open Exception: " + e , true ); return; }
					try {
             // Get the ContentType
//             String type = c.getType();
             // Get the length and process the data
//             int len = (int)c.getLength();

             portlog("Opened connection", true);

					String m = "My message";
					byte[] b = m.getBytes();
					os.write(b);

					portlog("Written message", true);

					}

   catch (Exception e) {portlog("Open Exception: " + e + " " + e.getMessage(), true); }

      finally {
      		try {
             if (os != null)os.close();
             if (c != null)c.close();
                } catch (Exception e) {portlog("Close Exception: " + e , true); }
         }
      }

/*-----------------------------------------------
	 try {
 		StreamConnection conn = null;
 		conn = (StreamConnection) Connector.open(uu);
 	} catch (Exception e) {log("URL Exception: "+ e + " " + uu); }
	}
------------------------------------------------*/
	private void sendSMS(String adr, String msg){
	 try {
 		MessageConnection conn = null;
 		conn = (MessageConnection) Connector.open(adr);
 		TextMessage tm = (TextMessage) conn.newMessage(MessageConnection.TEXT_MESSAGE);
 		tm.setPayloadText(msg);
 		portlog(msg, true);
    conn.send(tm);
 	} catch (Exception e) {portlog("sendSMS Exception: "+ e + " " + adr + " " + msg, true); }
	}

	private void showOperator(){
	 try {
	 		String deviceUrl =  "corbaloc::127.0.0.1:19740/Device";
			org.omg.CORBA.Object deviceRef = orb.string_to_object(deviceUrl);
			Device device=DeviceHelper.narrow(deviceRef);
	 		org.omg.CORBA.AnyHolder oval = new org.omg.CORBA.AnyHolder();
			device.getParam("OperatorList",oval);
			Operator[] zz = OperatorListHelper.extract(oval.value);
			portlog("Operator name is: " + zz[0].name, true);
 	} catch (Exception e) {portlog("showOperator Exception: "+ e, true); }
	}

	private static int U2toInt(int[] U2)  {
			int l=0;
			l=(U2[0]&0x000000ff)|((U2[1]<<8)&0x0000ff00);
			return l;
		}
	private static long U4tolong(int[] U4)  {
			long l=0;
			l=(U4[0]&0x00000000000000ff)|((U4[1]<<8)&0x000000000000ff00)|((U4[2]<<16)&0x0000000000ff0000)|((U4[3]<<24)&0x00000000ff000000);
			return l;
		}
	private static int I4toInt(int[] I4)  {
			// Dataene er lagret i Little endian format
			int l=0;
			if (((I4[0]<<24)&0x80000000) == 0x80000000){
				l=0;
				// Vi har et negativt tall
				l = -(((I4[3]<<24)&0xff000000)^0xff000000)-(((I4[2]<<16)&0x00ff0000)^0x00ff0000)
				-(((I4[1]<<8)&0x0000ff00)^0x0000ff00)-(((I4[0])&0x000000ff)^0x000000ff)-1;
			} else {
				l = ((I4[3]<<24)&0x7f000000)+((I4[2]<<16)&0x00ff0000)+((I4[1]<<8)&0x0000ff00)+((I4[0])&0x000000ff);
			}
			return l;
	}
	private static int I2toInt(int[] I2)  {
			// Dataene er lagret i Little endian format
			int l=0;
			if (((I2[0]<<8)&0x8000) == 0x8000){
				l=0;
				// Vi har et negativt tall
				l = -(((I2[1]<<8)&0xff00)^0xff00)-(((I2[0])&0x00ff)^0x00ff)-1;
			} else {
				l = ((I2[1]<<8)&0x0000ff00)+((I2[0])&0x000000ff);
			}
			return l;
	}
	private boolean checksum_ok(int [] data)  {
		int ck_a = data[(data.length)-2]&0xff;
		int ck_b = data[(data.length)-1]&0xff;
		//portlog("ck_a er: " + ck_a +"  og ck_b er: " + ck_b,true);
		int cka = 0;
		int ckb = 0;
		for (int i = 2; i < ((data.length)-2); i++)  {
			cka = (cka + data[i]) & 0xff;
			ckb = (ckb + cka) & 0xff;
		}
		//portlog("cka er: " + cka +"  og ckb er: " + ckb, true);
		if (cka == ck_a && ckb == ck_b)  {
			return true;
		} else {
			return false;
		}
	}

	public void portlog(String msg, boolean flag) {
			if (scoutStream != null && msg != null) {

				// prepare timestamp
				Calendar cal = Calendar.getInstance();
				if(msg.startsWith("$INI")) {
					//command =true;
				}
				// Print timestamp and message
				if(flag)msg = "$LOG: <[" + cal.toString().substring(5,25) + "] " + msg + ">\r";

				try {

					scoutStream.write(msg.getBytes());
	//				log("Done writing to outStream");
				} catch (IOException ignored) { log("Could not write message to " + uri + " " + ignored);
				}
			}
	//		log("Exit write to outStream");
			int ch = 0;
			int got = 0;
			try {
				got = scinStream.available();
				if(got > 0){
					byte[] data = new byte[got];
		       		int actual = scinStream.read(data);
					inData.addElement(data);
	//				throw new NullPointerException();
	//				log("Actually got: " + actual + " : " + new String(data));
	          	}
			}
	        catch (IOException ignored) { log("Could not read message from " + uri + " " + ignored);
			}
	//		log("Exit write to outStream " + got); */
	}
}
