package com.nokia.m2m.sdk.examples.device;

import com.nokia.m2m.imp.comm.CommConnection;
import com.nokia.m2m.imp.iocontrol.IOControl;
import com.nokia.m2m.orb.idl.iomodule.IOControlHelper;
import com.nokia.m2m.orb.idl.iomodule.IOControlObserverHelper;
import com.nokia.m2m.orb.idl.properties.EventsPackage.SMS_RECEIVED_TEXT;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistration;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistrationHelper;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistrationStatus;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.Operator;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.OperatorListHelper;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.SignalQualityHelper;
import com.nokia.m2m.orb.idl.terminal.ET;
import com.nokia.m2m.orb.idl.terminal.ETHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.Device;
import com.nokia.m2m.orb.idl.wirelessdevice.DeviceHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.EventObserverHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.ParamObserverHelper;
import com.nokia.m2m.sdk.examples.iomodule.*;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;
import com.nokia.m2m.sdk.examples.logger.SocketPortLogger;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;
import java.util.TimeZone;
import java.util.Vector;
import java.util.Enumeration;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.io.StreamConnection;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.wireless.messaging.MessageConnection;
import javax.wireless.messaging.TextMessage;
import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.CORBA.Policy;
import org.omg.PortableServer.IdAssignmentPolicyValue;
import org.omg.PortableServer.IdUniquenessPolicyValue;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import java.io.IOException;
import java.lang.Integer;


/**
 * MessageObserverIMlet listens for incoming short messages and sends 
 * a response message back to the sender. This implementation uses
 * event listener approach.
 * 
 * 
 */
public class SeatexIMlet extends MIDlet {

	ORB orb;	
	private static final int OUTPUT_PIN_1 = 7;
	private static final int OUTPUT_PIN_2 = 6;
	private static final int OUTPUT_PIN_3 = 9;
	private static final int INPUT_PIN_1 = 6; // toggle
	private static final int INPUT_PIN_2 = 9; // toggle
	private static final int INPUT_PIN_3 = 7; // switch
	private static final String urls[] = {"sms://+4799517017" };
	private static final String version = "0.25";
	private static final Vector fifo = new Vector();
	private static final int year = 2005;
	private static final int month = 8;
	private static final int dato = 16;
	private int cell_id;
	
	private OutputStream outStream = null;
	private StreamConnection sc = null;
	private InputStream inStream = null;
	
		// UBX protocol headers
	final static String AID_DATA  = "#b5#62#0b#10";		// Start of AID_DATA msg
	final static String CFG_MSG   = "0xb50x620x060x010x060x000x0b0x000x000x000x010x000x190xb9";	// Request aiding on target 2
	final int[] int_CFG_MSG   = { 0xb5,0x62,0x06,0x01,0x06,0x00,0x0b,0x00,0x00,0x00,0x01,0x00,0x19,0xb9 } ;	// Request aiding on target 2
	final static String CFG_RST   = "0xb50x620x060x040x040x000xff0x070x020x000x160x79";	// Cold reset
	final int[] int_CFG_RST = { 0xb5,0x62,0x06,0x04,0x04,0x00,0xff,0x07,0x02,0x00,0x16,0x79 }; // Cold reset

	/**
	 * Start application
	 */
	protected void startApp() throws MIDletStateChangeException {

		try {
			
			Calendar cal = Calendar.getInstance();
			cal.setTimeZone(TimeZone.getTimeZone("GMT"));
			cal.set(Calendar.YEAR,year);
			cal.set(Calendar.MONTH,month);
			cal.set(Calendar.DATE,dato);
			cal.set(Calendar.HOUR, 15);
			cal.set(Calendar.MINUTE, 30);
								
			portlog("SeatexIMlet starting ver. " + version + " " + dato + "," + month + "," + year + ", Telenor ASA, Sune Jakobsson",true);

			// Initialize ORB in IIOP mode. This IMlet does not do wireless
			// communications.
			Hashtable props = new Hashtable();
			props.put("com.nokia.m2m.orb.UseM2MGateway", "no");
			orb = ORB.init(null, props);
			// 
			// Get the RootPOA.
			//
			org.omg.PortableServer.POA rootPoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
			//
			// Create a new POA. Use persistent policies
			// so that servants activated under
			// this POA will always get the same IOR. This ensures 
			// that when the IMlet is restarted
			// after Nokia 12 module reboot, the new reqistration will 
			// overwrite the existing reqistration.
			//
			Policy[] policies =
				new Policy[] {
					rootPoa.create_id_assignment_policy(IdAssignmentPolicyValue.USER_ID),
					rootPoa.create_id_uniqueness_policy(IdUniquenessPolicyValue.UNIQUE_ID),
					rootPoa.create_lifespan_policy(LifespanPolicyValue.PERSISTENT)};
			//
			// Name the new POA as 'SmsObserverPOA' this name will be part of
			// the listener objects object key. Object key can be freely chosen.
			//
			POA observerPoa = rootPoa.create_POA("ObserverPOA", rootPoa.the_POAManager(), policies);
			// Resolve the Embedded Terminal object. This is needed to send response shortmessages.
			String etUrl =  "corbaloc::127.0.0.1:19740/ORB/OA/IDL:ET:1.0";
			org.omg.CORBA.Object etRef = orb.string_to_object(etUrl);
			ET et = ETHelper.narrow(etRef);
			
			String deviceUrl =  "corbaloc::127.0.0.1:19740/Device";
			org.omg.CORBA.Object deviceRef = orb.string_to_object(deviceUrl);
			Device device=DeviceHelper.narrow(deviceRef);

			// Get a reference to the IO module
			String ioUrl = "corbaloc::127.0.0.1:19740/ORB/OA/IDL:IOModule/IOControl:1.0";
			org.omg.CORBA.Object ioRef = orb.string_to_object(ioUrl);
			com.nokia.m2m.orb.idl.iomodule.IOControl iocontrol = IOControlHelper.narrow(ioRef);
			// 
			// Initialize the servant object. Give embedded terminal to the observer so that it can
			// use et methods to send response shortmessage back to the sender. Object id can be freely
			// chosen.
			//
			MessageObserverImpl messObserverImpl = new MessageObserverImpl(et, fifo);
			observerPoa.activate_object_with_id("SMSObserver".getBytes(), messObserverImpl);
			SignalQualityObserverImpl sigObserverImpl = new SignalQualityObserverImpl();
			observerPoa.activate_object_with_id("SignalQualityObserver".getBytes(), sigObserverImpl);
//			IOControlObserverImpl ioObserverImpl = new IOControlObserverImpl();
//			observerPoa.activate_object_with_id("IOObserver".getBytes(), ioObserverImpl);
			//
			// Activate the POAManager. 
			// Activation starts request processing in all POAs that 
			// use this POAManager.
			//
			rootPoa.the_POAManager().activate();
			//
			// The observer is now ready to receive events.
			// Register the listener into the Module ORB.
			//
			// Get CORBA object reference from servant
			Object messObserverObj = observerPoa.servant_to_reference(messObserverImpl);
			Object sigObserverObj = observerPoa.servant_to_reference(sigObserverImpl);
//			Object ioObserverObj = observerPoa.servant_to_reference(ioObserverImpl);
			portlog("Setting observers",true);			
			try { 
					// Start to listen to the SMS reception.
					device.setEventObserver("SMS-RECEIVED-TEXT", EventObserverHelper.narrow(messObserverObj));
					// Activate also SMS-RECEIVED-UNRESOLVED if you want to receive binary short messages.
					// Same observer object can be set to listen multiple different events
					device.setEventObserver("SMS-RECEIVED-UNRESOLVED", EventObserverHelper.narrow(messObserverObj));
					// Start to listen to the SignalQuality parameter.
					device.setParamObserver("SignalQuality", ParamObserverHelper.narrow(sigObserverObj));
					
//					short[] pinList = new short[] { 5, 6, 7, 8, 9, 10, 11 };
//					iocontrol.setIOControlObserver(IOControlObserverHelper.narrow(ioObserverObj),pinList);
			  }
			catch (Exception e) {portlog("Failed setting observers: " + e , true); } 				

			portlog("Observers are set. Waiting for events...",true);
// ----------------------------------------------------------------------						
			org.omg.CORBA.AnyHolder nval = new org.omg.CORBA.AnyHolder();						
			boolean n_wait = true;
			while(n_wait){ 
			device.getParam("NetworkRegistration",nval);
			NetworkRegistration yy = NetworkRegistrationHelper.extract(nval.value);
			NetworkRegistrationStatus nrs = yy.status;			
			portlog("status is: " + nrs.value(), true); // Vent til denne er 1. NETWORK_REGISTRATION_REGISTERED_HOME
			portlog("areaCode is: " + yy.areaCode, true);
			portlog("cellID is: " + yy.cellID, true); 
			cell_id = yy.cellID;
//			if(nrs.value() == NetworkRegistrationStatus.NETWORK_REGISTRATION_REGISTERED_HOME) n_wait = false;
			if(nrs.value() == 1) n_wait = false;
			};
// ----------------------------------------------------------------------		
//			log("Show operator");	
//			showOperator(); // takes a long time, and fails occationally??
//			log("Done with operator");
// ----------------------------------------------------------------------			
			org.omg.CORBA.AnyHolder sval = new org.omg.CORBA.AnyHolder();						
			device.getParam("SignalQuality",sval);
			short sVal= SignalQualityHelper.extract(sval.value);
			portlog("Signal Quality is: " + sVal, true);
			sigObserverImpl.setValue(sVal);
// ----------------------------------------------------------------------	
			// Ask IMEI from the embedded terminal
			portlog("IMEI=" + et.IMEI(), true);
//			log("Now: " + System.currentTimeMillis());					
			boolean set1=false;
			boolean set2=false;
			boolean set3=false;
			int i = 0;
			int ad0 = 0;

//			ioObserverImpl.resetChange(5);
//			ioObserverImpl.resetChange(11);
			sendSMS(urls[0],"Seatex unit power up, version: " + version);
			
//			portlog("Unit: " + et.IMEI() + " is running", true);
			portlog("$INIT,UBX," + et.IMEI() + "," + cell_id + "\r", false);
			
			portlog("$INI\r", false);
			portlog("$ALM\r", false);
			portlog("$EPH\r", false);
			
			try {
			sc = (StreamConnection) Connector.open("comm:3;baudrate=57600", Connector.READ_WRITE);
			// Open outputStream
			outStream = sc.openOutputStream();
			inStream = sc.openInputStream();
		} catch (IOException ignored) { portlog("Failed opening of serial port to GPS device", true);
		}

			byte[] inbuffer = new byte[4096];
			int inputbytes=0;
			int actual=0;
			boolean gps_boot = true;
			boolean gps_reset = true;
			boolean serial_ack = false;

			while (true){ 
				
				try 
				{	
				inputbytes = inStream.available();			
				if(inputbytes > 0){
					
					actual = inStream.read(inbuffer, 0 , inputbytes);
					
					int starts = 0;
					for(int ix = 0; ix < actual ; ix++)if(inbuffer[ix] == (byte)0xB5) // Every Message starts with 2 Bytes: 0xB5 0x62 
						{
						if(inbuffer[ix+1] == (byte)0x62)
							{
							starts++;	 //		A 1 Byte Class Field follows. The Class defines the basic subset of the message		
							
							switch(	inbuffer[ix+2] ) 
								{	
								case (byte)0x01: 	  	
																	if(inbuffer[ix+3] == (byte)0x01)portlog("NAV-POSECEF (0x01 0x01)",true);
																	if(inbuffer[ix+3] == (byte)0x02)portlog("NAV-POSLLH (0x01 0x02)	",true);
																	if(inbuffer[ix+3] == (byte)0x03)portlog("NAV-STATUS (0x01 0x03)	",true);
																	if(inbuffer[ix+3] == (byte)0x04)portlog("NAV-DOP (0x01 0x04)		",true);
																	if(inbuffer[ix+3] == (byte)0x06)portlog("NAV-SOL (0x01 0x06)		",true);
																	if(inbuffer[ix+3] == (byte)0x08)portlog("NAV-POSUTM (0x01 0x08)	",true);
																	if(inbuffer[ix+3] == (byte)0x11)portlog("NAV-VELECEF (0x01 0x11)",true);
																	if(inbuffer[ix+3] == (byte)0x12)portlog("NAV-VELNED (0x01 0x12)	",true);
																	if(inbuffer[ix+3] == (byte)0x20)portlog("NAV-TIMEGPS (0x01 0x20)",true);
																	if(inbuffer[ix+3] == (byte)0x21)portlog("NAV-TIMEUTC (0x01 0x21)",true);
																	if(inbuffer[ix+3] == (byte)0x22)portlog("NAV-CLOCK (0x01 0x22)	",true);
																	if(inbuffer[ix+3] == (byte)0x30)portlog("NAV-SVINFO (0x01 0x30)	",true);
																	if(inbuffer[ix+3] == (byte)0x31)portlog("NAV-DGPS (0x01 0x31)		",true);
																	if(inbuffer[ix+3] == (byte)0x32)portlog("NAV-SBAS (0x01 0x32)		",true);
																	if(inbuffer[ix+3] == (byte)0x40)portlog("NAV-EKFSTATUS (0x01 0x40)",true);
																	break;           
								case (byte)0x02: portlog(" RXM Receiver Manager Messages: Pseudo Ranges, avg C/N0, Channel Status",true); break;                  
								case (byte)0x04: 
																	if(inbuffer[ix+3] == (byte)0x00)portlog("INF-ERROR (0x04 0x00)  ",true);
																	if(inbuffer[ix+3] == (byte)0x02)
																		{ 
																		String conv = new String(inbuffer, (ix+6) , (int)inbuffer[ix+4]);
																		if(conv.startsWith("ANTARIS"))gps_boot = true;
																		if(conv.startsWith("Reset"))gps_reset = true;
																		portlog("INF-NOTICE (0x04 0x02) " + inbuffer[ix+4] + " " + inbuffer[ix+5] + " " + conv,true);
																		}
																	if(inbuffer[ix+3] == (byte)0x03)portlog("INF-TEST (0x04 0x03)   ",true);
																	if(inbuffer[ix+3] == (byte)0x04)portlog("INF-DEBUG (0x04 0x04)  ",true);
																	if(inbuffer[ix+3] == (byte)0x07)portlog("INF-USER (0x04 0x07)   ",true);
								                  if(inbuffer[ix+3] == (byte)0x01)portlog("INF-WARNING (0x04 0x01)",true);
																	break;
								case (byte)0x05: 
																	if(inbuffer[ix+3] == (byte)0x01)
																		{
																		portlog("ACK-ACK (0x05 0x01)",true);
																		serial_ack = true;
																		}
																	if(inbuffer[ix+3] == (byte)0x00)portlog("ACK-NAK (0x05 0x00)",true);								
																	break;                                  
								case (byte)0x06: portlog(" CFG Configuration Input Messages: Set Dynamic Model, Set DOP Mask",true); break;                       
								case (byte)0x09: portlog(" UPD Firmware Update Messages",true);  break;                                                           
								case (byte)0x0A: 							
																	if(inbuffer[ix+3] == (byte)0x01)portlog("MON-SCHD (0x0A 0x01)  ",true);
																	if(inbuffer[ix+3] == (byte)0x02)portlog("MON-IO (0x0A 0x02)    ",true);
																	if(inbuffer[ix+3] == (byte)0x03)portlog("MON-IPC (0x0A 0x03)   ",true);
																	if(inbuffer[ix+3] == (byte)0x04)portlog("MON-VER (0x0A 0x04)   ",true);
																	if(inbuffer[ix+3] == (byte)0x05)portlog("MON-EXCEPT (0x0A 0x05)",true);
																	if(inbuffer[ix+3] == (byte)0x06)portlog("MON-MSGPP (0x0A 0x06) ",true);
																	if(inbuffer[ix+3] == (byte)0x07)portlog("MON-RXBUF (0x0A 0x07) ",true);
																	if(inbuffer[ix+3] == (byte)0x08)portlog("MON-TXBUF (0x0A 0x08) ",true);
																	if(inbuffer[ix+3] == (byte)0x09)portlog("MON-HW (0x0A 0x09)    ",true);
																	break; 								
								       
								case (byte)0x0B: portlog(" AID Navigation Aiding: Ephemeris, Almanac feeds",true); break;                                         
								case (byte)0x0D: portlog(" TIM Timing: Timepulse Output, Timemark Results",true); break;                                          
								case (byte)0x40: portlog(" USR SCK Customer Messages",true); break;
								default: portlog("Unknown Class field: " + inbuffer[ix+2], true);  
								}  
							}						
						}		
//					portlog("Got: " + actual+ " bytes with " + starts + " array starts with " + inbuffer[0] + " " + inbuffer[1]+ " " + 
//					inbuffer[2] + " " + inbuffer[3]+ " " + inbuffer[4] + " " + inbuffer[5]+ " " + inbuffer[6] + " " + inbuffer[7],true);
					}		
				}
				catch (Exception e) {System.out.println("Serial port Exception: "+ e ); } 

				
				
					try { 
				 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_1, (i&1)== 0);
				 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_2, (i&2)== 0);
				 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_3, (i&4)== 0);
				 			
//				 		ad0 = IOControl.getInstance().getAnalogInputPin (1);
				 			
				 			set1 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_1);
				 			set2 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_2);
				 			set3 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_3);
				  	 }
				   catch (Exception e) {System.out.println("IO Exception: "+ e ); } 
			  	 			
				try { 
					Thread.sleep(500); 
					} catch (InterruptedException interrupted) 
					{portlog("Interupt exception", true);}  
					
				if(fifo.size()>0)
					{						
					for ( Enumeration e = fifo.elements(); e.hasMoreElements() ;) {
						
								SMS_RECEIVED_TEXT msg = (SMS_RECEIVED_TEXT)e.nextElement();
								String content = msg.content;
								String from = msg.phoneNumber;
         				portlog("MSG: " + content + "' from " + from , true);
         				if(content.toUpperCase().startsWith("LOAD "))loadLink(content.substring(5));
         				if(content.toUpperCase().startsWith("OPEN "))openLink(content.substring(5));
     						}
     						
     			fifo.removeAllElements();
					};
					
				if(gps_boot)
				{
					serial_ack = false;
					sendString(CFG_RST);
					portlog("Send coldstart to GPS receiver", true);
					gps_boot = false;
				}

				if(gps_reset && serial_ack)
				{
					sendString(CFG_MSG);
					portlog("Send configuration to GPS receiver", true);
					gps_reset = false;
				}
				
				if((i%8)==0)
				{
				portlog(". Main: " + set1 + " " + set2 + " " + set3 + " FIFO: " + fifo.size() , true);
				
				}
				i++;
				}
//			orb.run();

		} catch (Exception e) {
			portlog("Error: " + e.toString(), true);
		}
		portlog("IMlet exited", true);
	}
	/**
	 * Writes a message to the serial port
	 * @param msg
	 */
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	private void portlog(String msg, boolean flag) {
		SocketPortLogger.getInstance().write(msg, flag);
	}
	/**
	 * Write a string of data to serial interface
	 * Data must be on the form 0x0b0xff
	 * @param data
	 */
	private void sendString(String data) {
			int c = 0;
			String b="";
			if (data.length()%4 != 0) {
				portlog("Error: each byte in data must have 4 characters (0x12). Data=" + data, true);
				return;
			}
			String str="";
			portlog("Sending: " + data, true);
			for (int i = 0; i < data.length(); i+=4) {
				b=data.substring(i+2, i+4);
				c = Integer.parseInt(b,16);

				try {
					outStream.write(c);
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
	}


	protected void pauseApp() {
		// This is not needed
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		// This is not needed
	}
	
	private void loadLink( String urli ) {
		
		portlog("Attempt to load: " + urli, true);
		
	       HttpConnection c = null;
         InputStream is = null;
         try {
             c = (HttpConnection)Connector.open(urli, Connector.READ, true); 
             // Getting the InputStream will open the connection
             // and read the HTTP headers. They are stored until
             // requested.
            }
         catch (Exception e) {portlog("Connector open Exception: " + e , true ); return; }
              
         try {
             is = c.openInputStream(); 
            }
             catch (Exception e) {portlog("Input stream open Exception: " + e , true ); return; }
					try {
             // Get the ContentType
//             String type = c.getType(); 
             // Get the length and process the data
//             int len = (int)c.getLength(); 
             
//             log("Opened connection with lenght: " + len + " and type: " + type);
             
             if (true) {
//             if (len > 0) {
                 byte[] data = new byte[64*8];
                 int actual = is.read(data);
//                 log("Actually got: " + actual + " bytes of type " + type);
                 portlog( new String(data), true);
                 
             } else {
                 int ch;
                 while ((ch = is.read()) != -1) {
                 }
             }
      }  
   catch (Exception e) {portlog("HTTP Exception: " + e , true); } 
      
      finally {
      		try {
             if (is != null)is.close();
             if (c != null)c.close();
                } catch (Exception e) {portlog("Close HTTP Exception: " + e, true ); } 
         }
      }
      
	private void openLink( String urli ) {
		
		portlog("Attempt to open: " + urli, true);
		
	       StreamConnection c = null;
         OutputStream os = null;
         try {
//             c = (StreamConnection)Connector.open(urli, Connector.WRITE, true); 
             os = Connector.openOutputStream(urli); 
             // Getting the InputStream will open the connection
             // and read the HTTP headers. They are stored until
             // requested.
//            }
//         catch (Exception e) {log("Connector open Exception: " + e  ); return; }
              
//         try {
//             os = c.openOutputStream(); 
            }
             catch (Exception e) {portlog("Output stream open Exception: " + e , true ); return; }
					try {
             // Get the ContentType
//             String type = c.getType(); 
             // Get the length and process the data
//             int len = (int)c.getLength(); 
             
             portlog("Opened connection", true);

					String m = "My message";
					byte[] b = m.getBytes();
					os.write(b);
					
					portlog("Written message", true);
					
					}	
        
   catch (Exception e) {portlog("Open Exception: " + e + " " + e.getMessage(), true); } 
      
      finally {
      		try {
             if (os != null)os.close();
             if (c != null)c.close();
                } catch (Exception e) {portlog("Close Exception: " + e , true); } 
         }
      }
		
/*-----------------------------------------------		
	 try {	 
 		StreamConnection conn = null;
 		conn = (StreamConnection) Connector.open(uu);	     
 	} catch (Exception e) {log("URL Exception: "+ e + " " + uu); } 							
	}		
------------------------------------------------*/	
	private void sendSMS(String adr, String msg){
	 try {	 
 		MessageConnection conn = null;
 		conn = (MessageConnection) Connector.open(adr);	     
 		TextMessage tm = (TextMessage) conn.newMessage(MessageConnection.TEXT_MESSAGE);
 		tm.setPayloadText(msg);
 		portlog(msg, true);
    conn.send(tm);         
 	} catch (Exception e) {portlog("sendSMS Exception: "+ e + " " + adr + " " + msg, true); } 							
	}
	
	private void showOperator(){
	 try {	 
	 		String deviceUrl =  "corbaloc::127.0.0.1:19740/Device";
			org.omg.CORBA.Object deviceRef = orb.string_to_object(deviceUrl);
			Device device=DeviceHelper.narrow(deviceRef);
	 		org.omg.CORBA.AnyHolder oval = new org.omg.CORBA.AnyHolder();						
			device.getParam("OperatorList",oval);
			Operator[] zz = OperatorListHelper.extract(oval.value);			
			portlog("Operator name is: " + zz[0].name, true);
 	} catch (Exception e) {portlog("showOperator Exception: "+ e, true); } 							
	}
}
