package com.nokia.m2m.sdk.examples.device;

import org.omg.CORBA.Any;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.SignalQualityHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.ParamObserverPOA;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;
import com.nokia.m2m.sdk.examples.logger.SocketPortLogger;

/**
 * This class implements ParamObserver interface by inheriting
 * ParamObserverPOA. SignalQualityIMlet creates instance of this
 * class and registers it to observe SignalQuality parameter.
 *
 * @see com.nokia.m2m.sdk.examples.device.SignalQualityIMlet
 */
public class SignalQualityObserverImpl extends ParamObserverPOA {

private short value;

	public short readValue() { return value; };
	public void setValue(short invalue) { value = invalue; };

	public void paramChanged(String paramName, Any oldValue, Any newValue) {

		// Check that the parameter is correct before
		// trying to extract values from Any. If wrong
		// event is raised extract will throw an exception.
		//
		if (paramName.equals("SignalQuality")) {

			//
			// Extract values from Any.
			//
			value = SignalQualityHelper.extract(newValue);

			log("SQO: SignalQuality: " + value);//, true);

		} else {
			log("SQO: Unknown paramChanged event: " + paramName);//, true);
		}
	}

	/**
	 * Write message to serial port
	 * @param msg
	 */
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}
	/*private void portlog(String msg, boolean flag) {
		SocketPortLogger.getInstance().write(msg, flag);
	}*/
}
