package com.nokia.m2m.sdk.examples.hello.impl;

import java.util.Hashtable;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import org.omg.CORBA.ORB;
import org.omg.CosNaming.*;
import com.nokia.m2m.sdk.examples.hello.idl.hello.*;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;
;

/**
 * Client IMlet for Hello World application.
 * 
 * 
 */
public class HelloClientImlet extends MIDlet {

	// Address of CORBA Name Service used resolve server location.
	private String NAMING_SERVICE_ADDRESS = "10.35.1.195:900";

	private ORB orb = null;
	public HelloClientImlet() {
		super();
	}

	protected void startApp() throws MIDletStateChangeException {
		try {

			log("HelloClientImlet starting");

			log("waiting ...");
			// wait to get into GSM network service
			Thread.sleep(30);
			log("continue");

			// Initialize the J2ME ORB in IIOP mode.
			Hashtable properties = new Hashtable();
			properties.put("com.nokia.m2m.orb.UseM2MGateway", "no");
			orb = ORB.init(null, properties);

			// Object URL is in format "corbaloc::10.35.1.195:9999/NameService"
			String nsURL = "corbaloc::" + NAMING_SERVICE_ADDRESS + "/NameService";
			org.omg.CORBA.Object nsRef = orb.string_to_object(nsURL);

			log("Resolving Naming Service");
			NamingContextExt nc = NamingContextExtHelper.narrow(nsRef);
			log("Resolving server");

			// Resolve "HelloServer" from Naming Service
			NameComponent[] nca = new NameComponent[] { new NameComponent("HelloServer", "")};
			log("Resolving HelloServer");
			// Throws exception if fails
			org.omg.CORBA.Object greeterRef = nc.resolve(nca);
			log("HelloServer found");
			// Now, narrow the Reference
			log("Narrowing HelloServer");
			Greeter greeter = GreeterHelper.narrow(greeterRef);

			// Make the invocation. 
			log("Invoking sayHello()");
			log(greeter.sayHello("IMlet-client"));

		} catch (Exception e) {
			log(e.toString());
		} finally {
			// Remember to destroy the ORB
			if (orb != null) {
				orb.destroy();
			}
		}
	}

	protected void pauseApp() {
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		if (orb != null) {
			orb.destroy();
		}
	}

	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}
}
