package com.nokia.m2m.sdk.examples.imletmanager;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.nokia.m2m.orb.ORB;
import com.nokia.m2m.orb.idl.imletmanager.IMlet;
import com.nokia.m2m.orb.idl.imletmanager.Suite;
import com.nokia.m2m.orb.idl.imletmanager.SuiteManager;
import com.nokia.m2m.orb.idl.imletmanager.SuiteManagerHelper;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;

public class StopDemo extends MIDlet {

	/**
	 * This example IMlet demostrates IMlets ability to do self stop using 
	 * IMlet suitemanager manager API
	 * 
	 * When the IMlet is stopped by using SuiteManager methods it will not start 
	 * after next reboot.
	 * 
	 * 
	 */
	public void startApp() throws MIDletStateChangeException {
		try {
			log("StopDemo starting");

			org.omg.CORBA.ORB orb = ORB.init(null, null);

			// Get a reference to the SuiteManager.
			String url = "corbaloc::127.0.0.1:19740/ORB/OA/IDL:SuiteManager:1.0";

			org.omg.CORBA.Object ref = orb.string_to_object(url);
			SuiteManager suiteManager = SuiteManagerHelper.narrow(ref);

			// Resolve the IMlet Suite and IMlet.
			Suite suite = suiteManager.getSuite("ExampleIMlets");
			IMlet me = suite.getIMlet("StopDemo");

			log("Waiting for 30 seconds...");
			Thread.sleep(30000);

			log("Stopping...");
			me.stop();

			// This row will never be reached because the IMlet
			// has already been stopped.
			log("Still running!");

		} catch (Exception e) {
			log("Error: " + e.toString());

		}
	}

	/**
	 * Print message to serial port 
	 */
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	public void pauseApp() {
	}

	public void destroyApp(boolean arg0) throws MIDletStateChangeException {
	}

}
