package com.nokia.m2m.sdk.examples.iocontrol;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.nokia.m2m.imp.iocontrol.IOControl;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;

/**
 * This IMlet demonstrates IOControl usage.
 * IMlet sets the output pin 7 on and off. 
 * This causes the led attached in the Nokia 12 test board to blink. 
 * 
 */
public class Blinker extends MIDlet {

	/** Used output port */
	private static final int OUTPUT_PIN_1 = 7;
	private static final int OUTPUT_PIN_2 = 6;
	private static final int OUTPUT_PIN_3 = 9;

	protected void startApp() throws MIDletStateChangeException {

		log("Blinker starting");

		int i=0;

		while (true) {

			try {

			Thread.sleep(500); i++;

 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_1, (i&1)== 0);
 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_2, (i&2)== 0);
 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_3, (i&4)== 0);
 			
 			log("Value of i=" + i);
 			
// 			ad0 = IOControl.getInstance().getAnalogInputPin (1);
 			
// 			set1 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_1);
// 			set2 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_2);
// 			set3 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_3);

			} catch (Exception e) {
				// Should not happen at runtime
				log(e.toString());
			}

		} 

	}

	/**
	 * Print a message to the serial port
	 * @param msg
	 */
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	protected void pauseApp() {
		// Not needed
	}

	protected void destroyApp(boolean unconditional) throws MIDletStateChangeException {
		// Not needed
	}

}
