package com.nokia.m2m.sdk.examples.iocontrol;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import com.nokia.m2m.imp.iocontrol.IOControl;
import javax.wireless.messaging.MessageConnection;
import javax.microedition.io.Connector;
import javax.wireless.messaging.TextMessage;
import javax.microedition.io.HttpConnection;
import com.nokia.m2m.imp.comm.CommConnection;
import java.io.DataOutputStream;
import java.io.DataInputStream;
import java.io.InputStream;

import com.nokia.m2m.orb.idl.terminal.ET;
import com.nokia.m2m.orb.idl.terminal.ETHelper;
import com.nokia.m2m.orb.idl.wirelessdevice.Device;
import com.nokia.m2m.orb.idl.wirelessdevice.DeviceHelper;
import com.nokia.m2m.orb.idl.terminal.ETPackage.MessageStorage;
import org.omg.CORBA.Object;
import org.omg.CORBA.StringHolder;
import com.nokia.m2m.orb.idl.wirelessdevice.DevicePackage.ParamValueListHolder;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.SignalQualityHelper;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistrationHelper;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistration;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.NetworkRegistrationStatus;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.OperatorListHelper;
import com.nokia.m2m.orb.idl.properties.ParametersPackage.Operator;

public class Blinker2 extends MIDlet {

	private static final int OUTPUT_PIN_1 = 7;
	private static final int OUTPUT_PIN_2 = 6;
	private static final int OUTPUT_PIN_3 = 9;
	private static final int INPUT_PIN_1 = 6; // toggle
	private static final int INPUT_PIN_2 = 9; // toggle
	private static final int INPUT_PIN_3 = 7; // switch

 	static CommConnection cm = null;
 	static DataOutputStream oser = null;
 	static DataInputStream iser = null;
 	static org.omg.CORBA.ORB orb = null;
 	static ET et = null;
 	static int errors = 0;

	protected void startApp() throws MIDletStateChangeException {

	serial_output so = new serial_output();
	so.stdout("Serial port initialized");

			try {

			orb = org.omg.CORBA.ORB.init(null, null);

			// Resolve reference to the Device object
			String url = "corbaloc::127.0.0.1:19740/Device";
			org.omg.CORBA.Object ref = orb.string_to_object(url);
			Device device = DeviceHelper.narrow(ref);

			so.stdout("Resolving ObjectNames");
			String[] nameList = device.getObjectNames();
			String names = "";
			for (int i = 0; i < nameList.length; i++) {
				names += nameList[i];
				if (i != nameList.length - 1) {
					names += ",";
				}
			}
			so.stdout("Object names " + names);
// ----------------------------------------------------------------------
			org.omg.CORBA.AnyHolder sval = new org.omg.CORBA.AnyHolder();
			device.getParam("SignalQuality",sval);
			short sVal= SignalQualityHelper.extract(sval.value);
			so.stdout("Signal Quality is: " + sVal);
// ----------------------------------------------------------------------

			org.omg.CORBA.AnyHolder nval = new org.omg.CORBA.AnyHolder();
			device.getParam("NetworkRegistration",nval);
			NetworkRegistration yy = NetworkRegistrationHelper.extract(nval.value);
			NetworkRegistrationStatus nrs = yy.status;

			so.stdout("status is: " + nrs.value());
			so.stdout("areaCode is: " + yy.areaCode);
			so.stdout("cellID is: " + yy.cellID);
// ----------------------------------------------------------------------

			org.omg.CORBA.AnyHolder oval = new org.omg.CORBA.AnyHolder();
			device.getParam("OperatorList",oval);
			Operator[] zz = OperatorListHelper.extract(oval.value);

			so.stdout("Operator name is: " + zz[0].name);
// ----------------------------------------------------------------------

			so.stdout("Resolving Embedded Terminal");
			Object etRef = device.getObjectRef("ET");
			et = ETHelper.narrow(etRef);

			// Ask IMEI from the embedded terminal
			so.stdout("IMEI=" + et.IMEI());

		} catch (Exception e) {
			so.stdout("Error: " + e.toString());

		}

		// Prepare the arguments for receiving SMS's.
		so.stdout("Check if SMS'es, wait for SMS message starting with 'Stop'");
		StringHolder msg = new StringHolder();
		StringHolder sender = new StringHolder();
		boolean loopfsms=true;
		java.lang.String rmessage = null;

		while (loopfsms) {

				for ( int xx = 0; xx < 12; xx++ ){

				try { // Throws an exception if there is no message.

					// received SMS's arrive in slot 0, and is then copied to an empty location.

				so.stdout("Attempt to read message ["+xx+"]");
				et.readShortMessage(MessageStorage.SIM, xx, msg, sender);
				so.stdout("Done reading message ["+xx+"]");
				// Message received.
				rmessage = msg.value;
				if(rmessage.startsWith("Stop"))loopfsms = false;
				so.stdout("Received message [" + xx + "]: " + rmessage + " from: "+ sender.value);
				// Remove message.

				if(xx>0){
				so.stdout("Attempt to remove message ["+xx+"]");
				et.removeShortMessage(MessageStorage.SIM,xx);
				so.stdout("Done removing message ["+xx+"]");
				}

				} catch (Exception ignored) {
				so.stdout("No msg in ["+xx+"](" + loopfsms + ") "+ ignored.toString());
					try {
					Thread.sleep(100);
					} catch (InterruptedException interrupted) {so.stdout("Interupt exception");} }
				}
			}

	String message = null;

	 try {
 	 		Thread.sleep(1000);
 	 		}
   		catch (Exception e) {System.out.println("Thread Exception: "+ e ); }


	int i = 0;
	boolean set1=false;
	boolean set2=false;
	boolean set3=false;
	int ad0 = 0;

	while(i<99){	i++;

	try {
 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_1, (i&1)== 0);
 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_2, (i&2)== 0);
 			IOControl.getInstance().setDigitalOutputPin(OUTPUT_PIN_3, (i&4)== 0);

 			ad0 = IOControl.getInstance().getAnalogInputPin (1);

 			set1 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_1);
 			set2 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_2);
 			set3 = IOControl.getInstance().getDigitalInputPin(INPUT_PIN_3);
  	 }
   catch (Exception e) {System.out.println("IO Exception: "+ e ); }

	 try {
 	 		Thread.sleep(500);
 	 		}
   		catch (Exception e) {System.out.println("Thread Exception: "+ e ); }

 	 so.stdout("IO ready (" + i + ") " + set1 + " " + set2 + " " + set3 + " " + ad0 + "mV " + System.currentTimeMillis());
/*
 	       HttpConnection c = null;
         InputStream is = null;
         String urli = "http://reidun.no-ip.com/vote.html";
         try {
             c = (HttpConnection)Connector.open(urli);
             // Getting the InputStream will open the connection
             // and read the HTTP headers. They are stored until
             // requested.
             is = c.openInputStream();
             // Get the ContentType
             String type = c.getType();
             // Get the length and process the data
             int len = (int)c.getLength();

             so.stdout("Opened connection with lenght: " + len + " and type: " + type);

             if (len > 0) {
                 byte[] data = new byte[len];
                 int actual = is.read(data);

                 message = "Actually got: " + actual + " bytes of type " + type;
                 so.stdout(message);

             } else {
                 int ch;
                 while ((ch = is.read()) != -1) {
                 }
             }
      }
   catch (Exception e) {so.stdout("HTTP Exception: "+ e ); }

      finally {
      		try {
             if (is != null)
                 is.close();
             if (c != null)
                 c.close();
                } catch (Exception e) {so.stdout("Close HTTP Exception: "+ e ); }
         }
*/ /*
 	 so.stdout("Attempt SMS");

	  // protocol and dialnumber
	 String urls = "sms://+4799517017";

	 try {
	 		MessageConnection conn = null;
	 		conn = (MessageConnection) Connector.open(urls);
	 		TextMessage tm = (TextMessage) conn.newMessage(MessageConnection.TEXT_MESSAGE);
	 		tm.setPayloadText(message + " " + i);
	    conn.send(tm);
   	} catch (Exception e) {so.stdout("SMS Exception: "+ e ); }
*/
		}
		so.destroy();
	}

   protected void pauseApp() {
   	// Not needed.
   	}
   protected void destroyApp(boolean unconditional) throws MIDletStateChangeException {
   	// Not needed.
   	}
  class serial_output
   {
   String urlser = "comm:3;baudrate=115200";

   public serial_output(){

 	 	try {
 	 		cm = (CommConnection)Connector.open(urlser);
 	 		oser = cm.openDataOutputStream();
 	 		iser = cm.openDataInputStream();
// 	 		oser.writeChars("Serial initialized\n\r");
// 	 		oser.flush();
 	 		} catch (Exception e) {System.out.println("SIO Exception: "+ e ); }
   	};
   	void stdout(String xx){
   		try {

   			int nn=0;
   		oser.writeChars( xx + " (" + (nn=iser.available()) + ")\n\r");
   			if(nn > 0){int ri = iser.readUnsignedByte(); oser.writeChars("Got: " + ri + " \n\r");}
   		oser.flush();
 	 			} catch (Exception e) {System.out.println("SIO destroy Exception: "+ e ); }
 	 		}

   	void destroy(){
   			try {
				oser.close();
				iser.close();
 	 			cm.close();
 	 			} catch (Exception e) {System.out.println("SIO destroy Exception: "+ e ); }
   		};
   	}
}