package com.nokia.m2m.sdk.examples.iomodule;

import com.nokia.m2m.orb.idl.iomodule.IOControlObserverPOA;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;

/**
 * Implementation of IOControlObserver. Instance of this class can 
 * be set to control IO pins.
 * 
 */
public class IOControlObserverImpl extends IOControlObserverPOA {

	/**
	 * Called when pin state change is detected.
	 */
	public void pinStateChanged(short pinNumber, int value) {

		// Simply print to log
		log("pinStateChanged, pin=" + pinNumber + " value=" + value);

		// Warning! Don't block this method for too long time. There is 
		// limited number of request processors available in the J2ME ORB 
		// and if all of them are blocked here, the module can not raise 
		// new events.

	}

	// Logging
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

}
