package com.nokia.m2m.sdk.examples.logger;

import java.io.IOException;
import java.io.OutputStream;
import java.io.InputStream;
import java.util.Calendar;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;

public class SocketPortLogger implements PortLog {

	private OutputStream outStream = null;
	private InputStream inStream = null;
	private static SocketPortLogger instance;
	private StreamConnection sc = null;
	private String uri = "socket://129.241.219.142:6667";

	/**
	 * Initialize the serial port
	 */
	private SocketPortLogger() {
		
//		log("Attempt to create stream to " + uri);
		try {
			sc = (StreamConnection) Connector.open(uri, Connector.READ_WRITE, true);
			// Open outputStstream
			outStream = sc.openOutputStream();
			inStream = sc.openInputStream();
		} catch (IOException ignored) { 
			log("Could not create stream to " + uri + " " + ignored); 
			return;
		}
//				log("Stream created to " + uri);
	}
	/**
	 * Write message to the socket port.
	 * 
	 */
	public void write(String msg, boolean flag) {
		if (outStream != null && msg != null) {

			// prepare timestamp
			Calendar cal = Calendar.getInstance();

			// Print timestamp and message
			if(flag)msg = "$LOG: <[" + cal.toString().substring(5,25) + "] " + msg + ">\r";

			try {

				outStream.write(msg.getBytes());
//				log("Done writing to outStream");
			} catch (IOException ignored) { log("Could not write message to " + uri + " " + ignored);
			}
		}
//		log("Exit write to outStream");
		int ch = 0;
		int got = 0;	
		try { 
			got = inStream.available();
			if(got > 0){ 
			           byte[] data = new byte[got];
                 int actual = inStream.read(data);
//                 log("Actually got: " + actual + " : " + new String(data));
                }
					} catch (IOException ignored) { log("Could not read message from " + uri + " " + ignored);
			}		
//		log("Exit write to outStream " + got);
	}
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}
	/**
	 * Returns instance of SocketPortLogger
	 * @return
	 */
	public static synchronized PortLog getInstance() {
		if (instance == null) {
			instance = new SocketPortLogger();
		}
		return instance;
	}

	/**
	 * Close the log. Release port resources.
	 */
	public void close() {
		if (outStream != null) {
			try {
				outStream.close();
			} catch (IOException ignored) { log("Could not close stream to " + uri + " " + ignored);
			}
		}
		if (inStream != null) {
			try {
				inStream.close();
			} catch (IOException ignored) { log("Could not close stream to " + uri + " " + ignored);
			}
		}
		if (sc != null) {
			try {
				sc.close();
			} catch (IOException ignored) { log("Could not close socket to " + uri + " " + ignored);
			}
		}
	}
}
