package com.nokia.m2m.sdk.examples.socket;

import javax.microedition.io.Connector;
import javax.microedition.io.Datagram;
import javax.microedition.io.DatagramConnection;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;

/**
 * Demonstrates datagram sending and receiving using 
 * connected datagram socket.
 * 
 */
public class DatagramClient extends MIDlet {

	public void startApp() throws MIDletStateChangeException {

		DatagramConnection conn = null;

		try {

			//
			// Open a connection to the target. This call 
			// opens the wireless link.
			//
			conn = (DatagramConnection) Connector.open("datagram://10.35.1.195:9000");

			//
			// Send "HELLO" to the server.
			//
			Datagram d;
			byte[] data = "HELLO".getBytes();
			d = conn.newDatagram(data, data.length);

			conn.send(d);

			// Allocate room to receive the response.
			Datagram resp = conn.newDatagram(1024);

			//
			// Receive the response. 
			// The method blocks until the datagram is received or the link 
			// is dropped.
			//
			conn.receive(resp);

			data = resp.getData();

			log("Response " + new String(data, 0, resp.getLength()));

		} catch (Exception e) {
			log(e.toString());

		} finally {
			if (conn != null) {
				try {
					conn.close();
				} catch (Exception ignored) {
				}
			}
		}

	}

	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	public void pauseApp() {
	}

	public void destroyApp(boolean arg0) throws MIDletStateChangeException {
	}

}
