package com.nokia.m2m.sdk.examples.socket;

import java.io.IOException;

import javax.microedition.io.Connector;
import javax.microedition.io.Datagram;
import javax.microedition.io.DatagramConnection;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;

/**
 * Demonstrates datagram receiving using datagram connection.
 * 
 */
public class DatagramServer extends MIDlet {

	public void startApp() throws MIDletStateChangeException {

		DatagramConnection dc = null;

		try {

			log("DatagramServer starting");

			//
			// Create a server socket to listen to the port. This call
			// does not open wireless link.
			//


			dc = (DatagramConnection) Connector.open("datagram://:9000");

			while (true) {

				Datagram dgram = dc.newDatagram(1200);

				// The call blocks until the datagram is reveived.
				dc.receive(dgram);
				
				log("Datagram received");

				// ... Process received data here ...

				//
				// Set the sender address as the new target address and
				// send the datagram back to the sender.
				// 
				dgram.setAddress(dgram.getAddress());

				try {
					
					//
					// Throws an IOException if the link is not open.	
					//
					dc.send(dgram);
					
				} catch (IOException ignored) {
				}

			}

		} catch (Exception e) {
			log(e.toString());
		} finally {
			if (dc != null) {
				try {
					dc.close();
				} catch (Exception ignored) {
				}
			}
		}

	}

	/**
	 * Write message to serial port
	 * @param msg
	 */
	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	public void pauseApp() {
	}

	public void destroyApp(boolean arg0) throws MIDletStateChangeException {
	}

}
