package com.nokia.m2m.sdk.examples.socket;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Calendar;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.io.StreamConnectionNotifier;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;


/**
 * Example of StreamConnectionNotifier usage. IMlets listens to port 80 for
 * incoming connections, reads data sent by the
 * client and returns a HTTP response.
 * 
 */
public class HTTPServerIMlet extends MIDlet {

	String HTTPStart = "";

	public void startApp() throws MIDletStateChangeException {

		DataInputStream in = null;
		DataOutputStream out = null;

		

		try {

			log("HTTPServerIMlet starting");
			
			// If the Nokia 12 Concept Simulator is used, use URL "serversocket://:80"
			StreamConnectionNotifier ssock = (StreamConnectionNotifier) Connector.open("socket://:80");

			while (true) {
				
			
				log("Going to accept and open");
				StreamConnection conn = ssock.acceptAndOpen();
				log("Accepted connection");

				try {

					in = conn.openDataInputStream();

					log("Receiving data");


					// TODO: implement proper reading!! This returns only some data.
					// Request reading is not needed in this example.
					while (in.available() == 0) {
						// wait for data
					}

					byte[] data = new byte[in.available()];
					in.read(data, 0, data.length);
					log("Data:'" + new String(data) + "'");

					out = conn.openDataOutputStream();

					/*
					 *  HTTP/1.0 200 OK
					 *  Content-type: text/html
					 *  Content-length: 345
					 * 
					 */

					
					// Prepare the response
					String HTML_RESP = "<HTML>Hello from IMlet!<BR>";
					HTML_RESP += "Time is " + Calendar.getInstance();
					HTML_RESP +="</HTML>";

					writeHTTPLine(out, "HTTP/1.0 200 OK");
					writeHTTPLine(out, "Content-type: text/html ");
					writeHTTPLine(out, ("Content-length: " + HTML_RESP.length()));
					// Empty line ends the header
					writeHTTPLine(out, "");

					log("Sending response");
					out.write(HTML_RESP.getBytes());

					out.flush();

					log("Closing connection");

				} catch (Exception ignored) {
				} finally {

					if (out != null) {
						try {
							out.close();
							out = null;
						} catch (Exception ignored) {
						}
					}

					if (in != null) {
						try {
							in.close();
						} catch (Exception ignored) {
						}
					}

					if (conn != null) {
						try {
							conn.close();
						} catch (Exception ignored) {
						}
					}


				}

			}

		} catch (Exception e) {
			log(e.toString());
			
			try{
				Thread.sleep(3000);
			}catch(Exception e2){
			}
				

		}

	}

	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	private void writeHTTPLine(OutputStream out, String data) throws IOException {
		// end with CRLF
		out.write((data + "\r\n").getBytes());
	}

	public void pauseApp() {

	}

	public void destroyApp(boolean arg0) throws MIDletStateChangeException {

	}

}
