package com.nokia.m2m.sdk.examples.terminal;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import org.omg.CORBA.StringHolder;

import com.nokia.m2m.orb.idl.terminal.ET;
import com.nokia.m2m.orb.idl.terminal.ETHelper;
import com.nokia.m2m.orb.idl.terminal.ETPackage.MessageStorage;
import com.nokia.m2m.sdk.examples.logger.SerialPortLogger;

/**
 *
 * This example IMlet demonstrates short message receiving
 * using Embedded Terminal CORBA interface.
 * 
 */
public class ETIMlet extends MIDlet {

	protected void startApp() throws MIDletStateChangeException {

		try {

			// Initialize ORB
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(null, null);

			// Resolve Embedded Terminal (ET) object
			String url = "corbaloc::127.0.0.1:19740/ORB/OA/IDL:ET:1.0";
			org.omg.CORBA.Object ref = orb.string_to_object(url);

			ET et = ETHelper.narrow(ref);

			// Prepare out arguments
			StringHolder msg = new StringHolder();
			StringHolder sender = new StringHolder();

			while (true) {
				try {

					// Throws ShortMessageIndexOutOfRangeException if there is no message
					et.readShortMessage(MessageStorage.SIM, 0, msg, sender);

					// Message received
					log("Received message: " + msg.value + " from: " + sender.value);

					// Remove message
					et.removeShortMessage(MessageStorage.SIM, 0);

				} catch (Exception e) {

					// wait a second before reading again
					Thread.sleep(1000);
				}
			}

		} catch (Exception e) {
		}

	}

	private void log(String msg) {
		SerialPortLogger.getInstance().write(msg);
	}

	protected void pauseApp() {

	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {

	}

}
