package com.telenor.agps;

/**
 * User: Ingebrigt Fuglem, Telenor FoU
 * Date: 29.nov.2004
 * Time: 15:30:37
 */
public class Ephemeris {
	int     prn;            //Satellite PRN number minus 1 (0 to 31)
	int     wn;             //GPS week number
	long    tow;            //Seconds of GPS week
	float   tgd;            //Group delay (seconds)
	long    aodc;           //Clock data issue
	long    toc;            //Clock data reference time in seconds
	float   af2;            //Clock correction (sec/sec2)
	float   af1;            //Clock correction (sec/sec)
	float   af0;            //Clock correction (sec)
	long    aode;           //Orbit data issue
	float   deltan;         //Mean anomaly correction (semicircles/sec)
	double  m0;             //Mean anomaly at reference time (semicircles)
	double  e;              //Eccentricity
	double  roota;          //Square root of semi-major axis (meters 1/2)
	long    toe;            //Reference time for orbit (sec)
	float   cic;            //Harmonic correction term (radians)
	float   crc;            //Harmonic correction term (meters)
	float   cis;            //Harmonic correction term (radians)
	float   crs;            //Harmonic correction term (meters)
	float   cuc;            //Harmonic correction term (radians)
	float   cus;            //Harmonic correction term (radians)
	double  omega0;         //Longitude of ascending node (semicircles)
	double  omega;          //Argument of perigee (semicircles)
	double  i0;             //Inclination angle (semicircles)
	float   omegadot;       //Rate of right ascension (semicircles/sec)
	float   idot;           //Rate of inclination (semicircles/sec)
	int     accuracy;       //User range accuracy
	int     health;         //Satellite health
	int     fit;            //Curve fit interval
}
